stages:
  - build
  - test
  - release

build:
  stage: build
  image: openjdk:17-jdk-alpine
  script:
    - apk add --no-cache maven
    - mvn dependency:go-offline -B
    - mvn package

test:
  stage: test
  image: openjdk:17-jdk-alpine
  script:
    - apk add --no-cache maven
    - mvn dependency:go-offline -B
    - mvn test
  artifacts:
    paths:
      - target/reports/

release:
  stage: release
  image: docker:latest
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375
  script:
    - 'docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME .'
    - 'docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY'
    - 'docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME'
  only:
    - main
    - develop